// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "HelloClient.h"
#include "DlgProxy.h"
#include "HelloClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelloClientDlgAutoProxy

IMPLEMENT_DYNCREATE(CHelloClientDlgAutoProxy, CCmdTarget)

CHelloClientDlgAutoProxy::CHelloClientDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CHelloClientDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CHelloClientDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CHelloClientDlgAutoProxy::~CHelloClientDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CHelloClientDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CHelloClientDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CHelloClientDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CHelloClientDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CHelloClientDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IHelloClient to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {6E65DFBF-439C-4E93-8785-B1B950C9E60B}
static const IID IID_IHelloClient =
{ 0x6e65dfbf, 0x439c, 0x4e93, { 0x87, 0x85, 0xb1, 0xb9, 0x50, 0xc9, 0xe6, 0xb } };

BEGIN_INTERFACE_MAP(CHelloClientDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CHelloClientDlgAutoProxy, IID_IHelloClient, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {3F05E99B-7995-4A4C-AAA6-359EC18F60C2}
IMPLEMENT_OLECREATE2(CHelloClientDlgAutoProxy, "HelloClient.Application", 0x3f05e99b, 0x7995, 0x4a4c, 0xaa, 0xa6, 0x35, 0x9e, 0xc1, 0x8f, 0x60, 0xc2)

/////////////////////////////////////////////////////////////////////////////
// CHelloClientDlgAutoProxy message handlers
