// HelloClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HelloClient.h"
#include "HelloClientDlg.h"
#include "DlgProxy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelloClientDlg dialog

IMPLEMENT_DYNAMIC(CHelloClientDlg, CDialog);

CHelloClientDlg::CHelloClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHelloClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHelloClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
}

CHelloClientDlg::~CHelloClientDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CHelloClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelloClientDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHelloClientDlg, CDialog)
	//{{AFX_MSG_MAP(CHelloClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BTN_DELPHI, OnBtnDelphi)
	ON_BN_CLICKED(IDC_BTN_BCB, OnBtnBcb)
	ON_BN_CLICKED(IDC_BTN_VB, OnBtnVb)
	ON_BN_CLICKED(IDC_BTN_VC, OnBtnVc)
	ON_BN_CLICKED(IDC_BTN_JS, OnBtnJs)
	ON_BN_CLICKED(IDC_BTN_VBS, OnBtnVbs)
	ON_BN_CLICKED(IDC_BTN_VFP, OnBtnVfp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelloClientDlg message handlers

BOOL CHelloClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHelloClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHelloClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CHelloClientDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CHelloClientDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void CHelloClientDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CHelloClientDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

#import ".\TLB\HelloDelphi.tlb" rename_namespace("delphi")
#import ".\TLB\HelloBCB.tlb" rename_namespace("bcb")
#import ".\TLB\HelloVB.tlb" rename_namespace("vb")
#import ".\TLB\HelloVC.tlb" rename_namespace("vc")
#import ".\TLB\HelloJS.tlb" rename_namespace("js")
#import ".\TLB\HelloVBS.tlb" rename_namespace("vbs")
#import ".\TLB\HelloVFP.tlb" rename_namespace("vfp")

// call Delphi server
void CHelloClientDlg::OnBtnDelphi() 
{
	BSTR retval;
	HRESULT hr = S_OK;
	delphi::IHelloPtr pHello = NULL;

	// get interface
	hr = pHello.CreateInstance(__uuidof(delphi::Hello));
    if (hr != S_OK)
	{
       MessageBoxW(NULL, L"Create HelloDelphi failed", L"Error", MB_OK);
       return;
	};

	// get string & show message
	retval = pHello->GetHelloString();
	MessageBoxW(NULL, retval, L"Info", MB_OK);
}

// call BCB server
void CHelloClientDlg::OnBtnBcb() 
{
	BSTR retval;
	HRESULT hr = S_OK;
	bcb::IHelloPtr pHello = NULL;

	// get interface
    hr = pHello.CreateInstance(__uuidof(bcb::Hello));
    if (hr != S_OK)
	{
       MessageBoxW(NULL, L"Create HelloBCB failed", L"Error", MB_OK);
       return;
	};

	// get string & show message
	retval = pHello->GetHelloString();
	MessageBoxW(NULL, retval, L"Info", MB_OK);
}

// call VB server
void CHelloClientDlg::OnBtnVb() 
{
	BSTR retval;
	HRESULT hr = S_OK;
	vb::_HelloPtr pHello = NULL;

	// get interface
    hr = pHello.CreateInstance(__uuidof(vb::Hello));
    if (hr != S_OK)
	{
       MessageBoxW(NULL, L"Create HelloVB failed", L"Error", MB_OK);
       return;
	};

	// get string & show message
	retval = pHello->GetHelloString();
	MessageBoxW(NULL, retval, L"Info", MB_OK);
}

// call VC server
void CHelloClientDlg::OnBtnVc() 
{
	BSTR retval;
	HRESULT hr = S_OK;
	vc::IHelloPtr pHello = NULL;

	// get interface
    hr = pHello.CreateInstance(__uuidof(vc::Hello));
    if (hr != S_OK)
	{
       MessageBoxW(NULL, L"Create HelloVC failed", L"Error", MB_OK);
       return;
	};

	// get string & show message
	retval = pHello->GetHelloString();
	MessageBoxW(NULL, retval, L"Info", MB_OK);
}

// call JS server
void CHelloClientDlg::OnBtnJs() 
{
	_variant_t retval;
	HRESULT hr = S_OK;
    js::AutomationPtr pHello = NULL;

	// get interface
	hr = pHello.CreateInstance(__uuidof(js::ScriptletCoClass));
	if (hr != S_OK)
	{
       MessageBoxW(NULL, L"Create HelloJS failed", L"Error", MB_OK);
       return;
	};

   	// get string & show message
    retval = pHello->GetHelloString("");
    MessageBoxW(NULL, retval.bstrVal, L"Info", MB_OK);
}

// call VBS server
void CHelloClientDlg::OnBtnVbs() 
{   
	// Unable to make it work 

	/*
	_variant_t retval;
	
	// get interface
    vbs::AutomationPtr pHello(__uuidof(vbs::ScriptletCoClass));

	// get string & show message
	retval = pHello->GetHelloString("");
	MessageBoxW(NULL, retval.bstrVal, L"Info", MB_OK);
	*/

	// Let's use COleDispatchDriver to make late bound call

    COleVariant retval;

    COleDispatchDriver oHello;
    if (!oHello.CreateDispatch("HelloVBS.Hello", NULL))
    {
        MessageBoxW(NULL, L"Create HelloVBS failed", L"Error", MB_OK);
        return;
    };

	oHello.InvokeHelper(0x1, DISPATCH_METHOD, VT_VARIANT, &retval, NULL);
    MessageBoxW(NULL, retval.bstrVal, L"Info", MB_OK);

}

void CHelloClientDlg::OnBtnVfp() 
{
	_variant_t retval;
	HRESULT hr = S_OK;
	vfp::IhelloPtr pHello = NULL;

	// get interface
    hr = pHello.CreateInstance(__uuidof(vfp::Hello));
    if (hr != S_OK)
	{
       MessageBoxW(NULL, L"Create HelloVFP failed", L"Error", MB_OK);
       return;
	};

	// get string & show message
	retval = pHello->gethellostring();
	MessageBoxW(NULL, retval.bstrVal, L"Info", MB_OK);
}
