// HELLOIMPL.H : Declaration of the THelloImpl

#ifndef IHelloImplH
#define IHelloImplH

#include "HelloBCB_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// THelloImpl     Implements IHello, default interface of Hello
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : HelloBCB.Hello
// Description    : Simple Borland C++ Hello server
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE THelloImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<THelloImpl, &CLSID_Hello>,
  public IDispatchImpl<IHello, &IID_IHello, &LIBID_HelloBCB>
{
public:
  THelloImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("HelloBCB.Hello");
  DECLARE_DESCRIPTION("Simple Borland C++ Hello server");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<THelloImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(THelloImpl)
  COM_INTERFACE_ENTRY(IHello)
  COM_INTERFACE_ENTRY2(IDispatch, IHello)
END_COM_MAP()

// IHello
public:
 
  STDMETHOD(GetHelloString(BSTR* result));
};

#endif //HelloImplH
